"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function (global) {
    var Loader = (function () {
        function Loader() {
            _classCallCheck(this, Loader);
        }

        _createClass(Loader, [{
            key: "hookAfterDelete",
            value: function hookAfterDelete() {
                // Modify the Delete window
                // Uses only pure-JS
                document.observe("ajaxplorer:afterApply-delete", function () {
                    try {
                        var u = pydio.getContextHolder().getUniqueNode();
                        if (u.getMetadata().get("ajxp_shared")) {
                            var f = document.querySelectorAll("#generic_dialog_box #delete_message")[0];
                            var alert = f.querySelectorAll("#share_delete_alert");
                            if (!alert.length) {
                                var message;
                                if (u.isLeaf()) {
                                    message = global.MessageHash["share_center.158"];
                                } else {
                                    message = global.MessageHash["share_center.157"];
                                }
                                f.innerHTML += "<div id='share_delete_alert' style='padding-top: 10px;color: rgb(192, 0, 0);'><span style='float: left;display: block;height: 60px;margin: 4px 7px 4px 0;font-size: 2.4em;' class='icon-warning-sign'></span>" + message + "</div>";
                            }
                        }
                    } catch (e) {
                        if (console) console.log(e);
                    }
                });
            }
        }], [{
            key: "loadInfoPanel",
            value: function loadInfoPanel(container, node) {
                if (!Loader.INSTANCE) {
                    Loader.INSTANCE = new Loader();
                    Loader.INSTANCE.hookAfterDelete();
                }
                var mainCont = container.querySelectorAll("#ajxp_shared_info_panel .infoPanelTable")[0];
                React.render(React.createElement(InfoPanel, { pydio: global.pydio, node: node }), mainCont);
            }
        }]);

        return Loader;
    })();

    var InfoPanelInputRow = React.createClass({
        displayName: "InfoPanelInputRow",

        propTypes: {
            inputTitle: React.PropTypes.string,
            inputValue: React.PropTypes.string,
            inputClassName: React.PropTypes.string,
            getMessage: React.PropTypes.func,
            inputCopyMessage: React.PropTypes.object
        },

        getInitialState: function getInitialState() {
            return { copyMessage: null };
        },

        componentDidMount: function componentDidMount() {
            this.attachClipboard();
        },
        componentDidUpdate: function componentDidUpdate() {
            this.attachClipboard();
        },

        attachClipboard: function attachClipboard() {
            if (this._clip) {
                this._clip.destroy();
            }
            if (!this.refs['copy-button']) {
                return;
            }
            this._clip = new Clipboard(this.refs['copy-button'].getDOMNode(), {
                text: (function (trigger) {
                    return this.props.inputValue;
                }).bind(this)
            });
            this._clip.on('success', (function () {
                this.setState({ copyMessage: this.props.getMessage(this.props.inputCopyMessage) }, this.clearCopyMessage);
            }).bind(this));
            this._clip.on('error', (function () {
                var copyMessage;
                if (global.navigator.platform.indexOf("Mac") === 0) {
                    copyMessage = this.props.getMessage('144');
                } else {
                    copyMessage = this.props.getMessage('143');
                }
                this.refs['input'].getDOMNode().focus();
                this.setState({ copyMessage: copyMessage }, this.clearCopyMessage);
            }).bind(this));
        },

        clearCopyMessage: function clearCopyMessage() {
            global.setTimeout((function () {
                this.setState({ copyMessage: '' });
            }).bind(this), 3000);
        },

        render: function render() {

            var select = function select(e) {
                e.currentTarget.select();
            };

            var copyMessage = null;
            if (this.state.copyMessage) {
                var setHtml = (function () {
                    return { __html: this.state.copyMessage };
                }).bind(this);
                copyMessage = React.createElement("div", { className: "copy-message", dangerouslySetInnerHTML: setHtml() });
            }
            return React.createElement(
                "div",
                { className: "infoPanelRow" },
                React.createElement(
                    "div",
                    { className: "infoPanelLabel" },
                    this.props.getMessage(this.props.inputTitle)
                ),
                React.createElement(
                    "div",
                    { className: "infoPanelValue", style: { position: 'relative' } },
                    React.createElement("input", {
                        ref: "input",
                        type: "text",
                        className: this.props.inputClassName,
                        readOnly: true,
                        onClick: select,
                        value: this.props.inputValue
                    }),
                    React.createElement("span", { ref: "copy-button", title: this.props.getMessage('191'), className: "copy-button icon-paste" }),
                    copyMessage
                )
            );
        }

    });

    var TemplatePanel = React.createClass({
        displayName: "TemplatePanel",

        propTypes: {
            node: React.PropTypes.instanceOf(AjxpNode),
            pydio: React.PropTypes.instanceOf(Pydio),
            getMessage: React.PropTypes.func,
            publicLink: React.PropTypes.string
        },

        getInitialState: function getInitialState() {
            return { show: false };
        },

        generateTplHTML: function generateTplHTML() {

            var editors = this.props.pydio.Registry.findEditorsForMime(this.props.node.getAjxpMime(), true);
            if (!editors.length) {
                return null;
            }

            var tplString = undefined;
            var messKey = "61";
            var newlink = ReactModel.Share.buildDirectDownloadUrl(this.props.node, this.props.publicLink, true);
            var template = global.pydio.UI.getSharedPreviewTemplateForEditor(editors[0], this.props.node);
            if (template) {
                tplString = template.evaluate({ WIDTH: 350, HEIGHT: 350, DL_CT_LINK: newlink });
            } else {
                tplString = newlink;
                messKey = "60";
            }
            return { messageKey: messKey, templateString: tplString };
        },

        render: function render() {
            var data = this.generateTplHTML();
            if (!data) {
                return null;
            }
            return React.createElement(InfoPanelInputRow, {
                inputTitle: data.messageKey,
                inputValue: data.templateString,
                inputClassName: "share_info_panel_link",
                getMessage: this.props.getMessage,
                inputCopyMessage: "229"
            });
        }

    });

    var InfoPanel = React.createClass({
        displayName: "InfoPanel",

        propTypes: {
            node: React.PropTypes.instanceOf(AjxpNode),
            pydio: React.PropTypes.instanceOf(Pydio)
        },

        getInitialState: function getInitialState() {
            return {
                status: 'loading',
                model: new ReactModel.Share(this.props.pydio, this.props.node)
            };
        },
        componentDidMount: function componentDidMount() {
            this.state.model.observe("status_changed", this.modelUpdated);
        },

        modelUpdated: function modelUpdated() {
            if (this.isMounted()) {
                this.setState({ status: this.state.model.getStatus() });
            }
        },

        getMessage: function getMessage(id) {
            try {
                return this.props.pydio.MessageHash['share_center.' + id];
            } catch (e) {
                return id;
            }
        },

        render: function render() {
            if (this.state.model.hasPublicLink()) {
                var linkData = this.state.model.getPublicLinks()[0];
                var isExpired = linkData["is_expired"];

                // Main Link Field
                var linkField = React.createElement(InfoPanelInputRow, {
                    inputTitle: "121",
                    inputValue: linkData['public_link'],
                    inputClassName: "share_info_panel_link" + (isExpired ? " share_info_panel_link_expired" : ""),
                    getMessage: this.getMessage,
                    inputCopyMessage: "192"
                });
                if (this.props.node.isLeaf() && this.props.pydio.getPluginConfigs("action.share").get("INFOPANEL_DISPLAY_DIRECT_DOWNLOAD")) {
                    // Direct Download Field
                    var downloadField = React.createElement(InfoPanelInputRow, {
                        inputTitle: "60",
                        inputValue: ReactModel.Share.buildDirectDownloadUrl(this.props.node, linkData['public_link']),
                        inputClassName: "share_info_panel_link",
                        getMessage: this.getMessage,
                        inputCopyMessage: "192"
                    });
                }
                if (this.props.node.isLeaf() && this.props.pydio.getPluginConfigs("action.share").get("INFOPANEL_DISPLAY_HTML_EMBED")) {
                    // HTML Code Snippet (may be empty)
                    var templateField = React.createElement(TemplatePanel, _extends({}, this.props, {
                        getMessage: this.getMessage,
                        publicLink: linkData.public_link
                    }));
                }
            }
            var users = this.state.model.getSharedUsers();
            var sharedUsersEntries = [],
                remoteUsersEntries = [];
            if (users.length) {
                sharedUsersEntries = users.map(function (u) {
                    var rights = [];
                    if (u.RIGHT.indexOf('r') !== -1) rights.push(global.MessageHash["share_center.31"]);
                    if (u.RIGHT.indexOf('w') !== -1) rights.push(global.MessageHash["share_center.181"]);
                    return React.createElement(
                        "div",
                        { key: u.ID, className: "uUserEntry" },
                        React.createElement(
                            "span",
                            { className: "uLabel" },
                            u.LABEL
                        ),
                        React.createElement(
                            "span",
                            { className: "uRight" },
                            rights.join(' & ')
                        )
                    );
                });
            }
            var ocsLinks = this.state.model.getOcsLinks();
            if (ocsLinks.length) {
                remoteUsersEntries = ocsLinks.map((function (link) {
                    var i = link['invitation'];
                    var status;
                    if (!i) {
                        status = '214';
                    } else {
                        if (i.STATUS == 1) {
                            status = '211';
                        } else if (i.STATUS == 2) {
                            status = '212';
                        } else if (i.STATUS == 4) {
                            status = '213';
                        }
                    }
                    status = this.getMessage(status);

                    return React.createElement(
                        "div",
                        { key: "remote-" + link.hash, className: "uUserEntry" },
                        React.createElement(
                            "span",
                            { className: "uLabel" },
                            i.USER,
                            " @ ",
                            i.HOST
                        ),
                        React.createElement(
                            "span",
                            { className: "uStatus" },
                            status
                        )
                    );
                }).bind(this));
            }
            if (sharedUsersEntries.length || remoteUsersEntries.length) {
                var sharedUsersBlock = React.createElement(
                    "div",
                    { className: "infoPanelRow" },
                    React.createElement(
                        "div",
                        { className: "infoPanelLabel" },
                        this.getMessage('54')
                    ),
                    React.createElement(
                        "div",
                        { className: "infoPanelValue" },
                        sharedUsersEntries,
                        remoteUsersEntries
                    )
                );
            }

            return React.createElement(
                "div",
                null,
                linkField,
                downloadField,
                templateField,
                sharedUsersBlock
            );
        }

    });

    global.ShareInfoPanel = {};
    global.ShareInfoPanel.loader = Loader.loadInfoPanel;
})(window);
